/*
 * Copyright (C) 2020, Inria
 * GRAPHDECO research group, https://team.inria.fr/graphdeco
 * All rights reserved.
 *
 * This software is free for non-commercial, research and evaluation use 
 * under the terms of the LICENSE.md file.
 *
 * For inquiries contact sibr@inria.fr and/or George.Drettakis@inria.fr
 */


#ifndef _ULRV2REPETITIONS_VIEW_H_
# define _ULRV2REPETITIONS_VIEW_H_

# include "Config.hpp"
# include <core/system/Config.hpp>
# include <core/graphics/Mesh.hpp>
# include <core/renderer/CopyRenderer.hpp>
# include <projects/ulr/renderer/ULRV2Renderer.hpp>
# include <core/renderer/PoissonRenderer.hpp>
# include "ULRRepetitionsRenderer.hpp"
# include "RepetitionsReflectionRenderer.hpp"
#include "core/view/ViewBase.hpp"


namespace sibr
{
	/**
	* Render a facade as generated by the Exploiting Repetitions for Image-Based Rendering of Facades pipeline.
	*/
	class SIBR_FACADE_REPETITIONS_EXPORT ULRRepetitionsView : public ViewBase
	{
	SIBR_CLASS_PTR(ULRRepetitionsView);

	public:


		/**
		 * \brief View constructor.
		 * \param ibrScene The IBR scene containing the facade.
		 * \param w rendering width
		*  \param h rendering height
		 */
		ULRRepetitionsView(const BasicIBRScene::Ptr& ibrScene, uint w, uint h);

		/**
		 * \brief View destructor.
		 */
		~ULRRepetitionsView();

		/**
		 * \brief Render the scene.
		 * \param dst The render target to render to.
		 * \param eye The current camera.
		 */
		void onRenderIBR(IRenderTarget& dst, const Camera& eye) override;

		/**
		 * \brief Update per-frame data based on user input.
		 * \param input The user input.
		 */
		void onUpdate(Input& input) override;

		
		/**
		 * \brief Select cameras for ULR rendering.
		 * \param eye The current camera.
		 * \param onlyFull If true, only select input scene cameras.
		 * \return A vector containing selected cameras indices.
		 */
		virtual std::vector<uint> chosen_cameras(const Camera& eye, bool onlyFull);

		/**
		 * \brief Rendering mode for comparisons.
		 */
		enum MeshMode
		{
			APPROX,
			PLANE,
			RC,
			SEGFULL
		};

	protected:

		// Renderers
		ULRRepetitionsRenderer::Ptr _ulr;
		RepetitionsReflectionRenderer::Ptr _reflections;
		PoissonRenderer::Ptr _poisson;

		std::vector<Mesh::Ptr> _meshs;

		unsigned int _numDistUlr;

		RenderTargetRGBA::Ptr _ulrDest;
		RenderTargetRGBA::Ptr _poissonDest;

		Texture2DRGB::Ptr _envmap;
		Vector3f _planeNormal;
		Matrix4f _envmapMat;
		bool _canDoReflections;
		bool _doReflections;

		MeshMode _mode;
		bool _allImages;
		bool _showinfos;
		size_t _fullCamCount;

		Texture2DArrayRGBA::Ptr _inputImages;
		std::vector<Texture2DArrayLum32F::Ptr> _inputDepths;
		bool _usePoisson;
		BasicIBRScene::Ptr _scene;
	};
} /*namespace sibr*/

#endif // _ULRV2_VIEW_H_
